// Code generated by go-swagger; DO NOT EDIT.

package virtual_machines

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the generate command

import (
	"errors"
	"net/url"
	golangswaggerpaths "path"

	"github.com/go-openapi/swag"
)

// VMListURL generates an URL for the vm list operation
type VMListURL struct {
	Limit  *int32
	Search *string
	Skip   *int32
	Sort   *int32
	Type   *int64

	_basePath string
	// avoid unkeyed usage
	_ struct{}
}

// WithBasePath sets the base path for this url builder, only required when it's different from the
// base path specified in the swagger spec.
// When the value of the base path is an empty string
func (o *VMListURL) WithBasePath(bp string) *VMListURL {
	o.SetBasePath(bp)
	return o
}

// SetBasePath sets the base path for this url builder, only required when it's different from the
// base path specified in the swagger spec.
// When the value of the base path is an empty string
func (o *VMListURL) SetBasePath(bp string) {
	o._basePath = bp
}

// Build a url path and query string
func (o *VMListURL) Build() (*url.URL, error) {
	var _result url.URL

	var _path = "/api/vms"

	_basePath := o._basePath
	_result.Path = golangswaggerpaths.Join(_basePath, _path)

	qs := make(url.Values)

	var limitQ string
	if o.Limit != nil {
		limitQ = swag.FormatInt32(*o.Limit)
	}
	if limitQ != "" {
		qs.Set("limit", limitQ)
	}

	var searchQ string
	if o.Search != nil {
		searchQ = *o.Search
	}
	if searchQ != "" {
		qs.Set("search", searchQ)
	}

	var skipQ string
	if o.Skip != nil {
		skipQ = swag.FormatInt32(*o.Skip)
	}
	if skipQ != "" {
		qs.Set("skip", skipQ)
	}

	var sortQ string
	if o.Sort != nil {
		sortQ = swag.FormatInt32(*o.Sort)
	}
	if sortQ != "" {
		qs.Set("sort", sortQ)
	}

	var typeVarQ string
	if o.Type != nil {
		typeVarQ = swag.FormatInt64(*o.Type)
	}
	if typeVarQ != "" {
		qs.Set("type", typeVarQ)
	}

	_result.RawQuery = qs.Encode()

	return &_result, nil
}

// Must is a helper function to panic when the url builder returns an error
func (o *VMListURL) Must(u *url.URL, err error) *url.URL {
	if err != nil {
		panic(err)
	}
	if u == nil {
		panic("url can't be nil")
	}
	return u
}

// String returns the string representation of the path with query string
func (o *VMListURL) String() string {
	return o.Must(o.Build()).String()
}

// BuildFull builds a full url with scheme, host, path and query string
func (o *VMListURL) BuildFull(scheme, host string) (*url.URL, error) {
	if scheme == "" {
		return nil, errors.New("scheme is required for a full url on VMListURL")
	}
	if host == "" {
		return nil, errors.New("host is required for a full url on VMListURL")
	}

	base, err := o.Build()
	if err != nil {
		return nil, err
	}

	base.Scheme = scheme
	base.Host = host
	return base, nil
}

// StringFull returns the string representation of a complete url
func (o *VMListURL) StringFull(scheme, host string) string {
	return o.Must(o.BuildFull(scheme, host)).String()
}
